use std::str::Utf8Error;

pub mod args;
pub mod conf;

#[inline]
pub fn decode(buf: &[u8]) -> Result<String, Utf8Error> {
    Ok(match std::str::from_utf8(buf) {
        Ok(s) => s.to_string(),
        Err(err) => return Err(err.into()),
    }
    .trim_matches(char::from(0))
    .to_string())
}
